/*******************************************************************************
* KindEditor - WYSIWYG HTML Editor for Internet
* Copyright (C) 2006-2011 kindsoft.net
*
* @author Roddy <luolonghao@gmail.com>
* @site http://www.kindsoft.net/
* @licence http://www.kindsoft.net/license.php
*******************************************************************************/

KindEditor.plugin('pdf', function (K) {
    var self = this, name = 'pdf',
		allowPdfUpload = K.undef(self.allowPdfUpload, true),
		allowPdfManager = K.undef(self.allowPdfManager, false),
		formatUploadUrl = K.undef(self.formatUploadUrl, true),
		uploadJson = K.undef(self.uploadJson, self.basePath + 'php/upload_json.php'),
		extraParams = K.undef(self.extraFileUploadParams, {}),
		filePostName = K.undef(self.filePostName, 'imgFile'),
		lang = self.lang(name + '.');

    self.plugin.pdfDialog = function (options) {
        var pdfUrl = K.undef(options.pdfUrl, 'http://'),
			pdfTitle = K.undef(options.pdfTitle, ''),
            pdfWidth = K.undef(options.pdfWidth, ''),
			pdfHeight = K.undef(options.pdfHeight, ''),
			clickFn = options.clickFn;
        var html = [
			'<div style="padding:20px;">',
			'<div class="ke-dialog-row">',
			'<label for="keUrl" style="width:60px;">' + lang.url + '</label>',
			'<input type="text" id="keUrl" name="url" class="ke-input-text" style="width:160px;" /> &nbsp;',
			'<input type="button" class="ke-upload-button" value="' + lang.upload + '" /> &nbsp;',
			'<span class="ke-button-common ke-button-outer">',
			'<input type="button" class="ke-button-common ke-button" name="viewServer" value="' + lang.viewServer + '" />',
			'</span>',
			'</div>',
            //width
			'<div class="ke-dialog-row">',
			'<label for="keWidth" style="width:60px;">' + lang.width + '</label>',
			'<input type="text" id="keWidth" class="ke-input-text ke-input-number" name="width" value="800" maxlength="4"/> ',
			'</div>',
            //height
			'<div class="ke-dialog-row">',
			'<label for="keHeight" style="width:60px;">' + lang.height + '</label>',
			'<input type="text" id="keHeight" class="ke-input-text ke-input-number" name="height" value="600" maxlength="4"/> ',
			'</div>',
			//form end
			'</form>',
			'</div>'
        ].join('');
        var dialog = self.createDialog({
            name: name,
            width: 450,
            title: self.lang(name),
            body: html,
            yesBtn: {
                name: self.lang('yes'),
                click: function (e) {
                    var url = K.trim(urlBox.val()),
                        width = widthBox.val(),
                        height = heightBox.val(),
						title = titleBox.val();
                    if (url == 'http://' || K.invalidUrl(url)) {
                        alert(self.lang('invalidUrl'));
                        urlBox[0].focus();
                        return;
                    }
                    if (!/^\d*$/.test(width)) {
                        alert(self.lang('invalidWidth'));
                        widthBox[0].focus();
                        return;
                    }
                    if (!/^\d*$/.test(height)) {
                        alert(self.lang('invalidHeight'));
                        heightBox[0].focus();
                        return;
                    }
                    if (K.trim(title) === '') {
                        title = url;
                    }
                    clickFn.call(self, url, title);
                }
            }
        }),
		div = dialog.div;
		
        var urlBox = K('[name="url"]', div),
			viewServerBtn = K('[name="viewServer"]', div),
			titleBox = K('[name="title"]', div),
			widthBox = K('[name="width"]', div),
		    heightBox = K('[name="height"]', div);
        urlBox.val('http://');

        if (allowPdfUpload) {
            var uploadbutton = K.uploadbutton({
                button: K('.ke-upload-button', div)[0],
                fieldName: filePostName,
                url: K.addParam(uploadJson, 'dir=file'),
                extraParams: extraParams,
                afterUpload: function (data) {
                    dialog.hideLoading();
                    if (data.error === 0) {
                        var url = data.url;
                        if (formatUploadUrl) {
                            url = K.formatUrl(url, 'absolute');
                        }
                        urlBox.val(url);
                        if (self.afterUpload) {
                            self.afterUpload.call(self, url, data, name);
                        }
                        alert(self.lang('uploadSuccess'));
                    } else {
                        alert(data.message);
                    }
                },
                afterError: function (html) {
                    dialog.hideLoading();
                    self.errorDialog(html);
                }
            });
            uploadbutton.fileBox.change(function (e) {
                dialog.showLoading(self.lang('uploadLoading'));
                uploadbutton.submit();
            });
        } else {
            K('.ke-upload-button', div).hide();
        }
        if (allowPdfManager) {
            viewServerBtn.click(function (e) {
                self.loadPlugin('filemanager', function () {
                    self.plugin.filemanagerDialog({
                        viewType: 'LIST',
                        dirName: 'file',
                        clickFn: function (url, title) {
                            if (self.dialogs.length > 1) {
                                K('[name="url"]', div).val(url);
                                if (self.afterSelectFile) {
                                    self.afterSelectFile.call(self, url);
                                }
                                self.hideDialog();
                            }
                        }
                    });
                });
            });
        } else {
            viewServerBtn.hide();
        }
        urlBox.val(pdfUrl);
        titleBox.val(pdfTitle);
        urlBox[0].focus();
        urlBox[0].select();
    };
    var originalWidth = 800, originalHeight = 600;
    function setSize(width, height) {
        widthBox.val(width);
        heightBox.val(height);
        originalWidth = width;
        originalHeight = height;
    }
    self.clickToolbar(name, function () {
        self.plugin.pdfDialog({
            clickFn: function (url, title) {
                var self = this;
                lang = self.lang(name + '.');
                var html = '<p></br></p><iframe width="' + originalWidth + '" height="'+originalHeight+'" src="' + url + '"></iframe>';
                self.insertHtml(html).hideDialog().focus();
            }
        });
    });
});
